<script>
import { ref, computed, onMounted, reactive } from "vue";
import store from "@/store"
import useValidate from "@vuelidate/core";
import { required, email, minLength, sameAs, helpers } from "@vuelidate/validators";
import { HTTP } from "@/components/common/HttpCommon";

import Loading from '@/components/item/Loading.vue';
import CheckoutForm from '@/components/forms/CheckoutForm.vue';
import ProductForm from '@/components/forms/ProductForm.vue';
export default {
  components: { Loading, CheckoutForm, ProductForm },
  name: 'KeranjangView',
  props: {
  },
  data() {
    return {
        formTitle: null,
        showForm : false,
        modalShow: false,
        modalCheckOutShow: false,
        modalShow: false,
        formData: null,
        userId: store.state.userId,
        userRole: store.state.userRole,
        checkOutData: null
    }
  },
  setup() {
    const data = ref(null);
    const size = ref(0);
    const loading = ref(false);
    const error = ref(null);
    const state = reactive({
            name : '',
            email : '',
            username : '',
            password : {
               confirm: '',
               password: ''
            },
            agree : false
         });
    const rules = computed(() => {
         return {
            name : { required },
            email : { required, email },
            username : { required },
            password : { 
               password : {required },
               confirm : { required, sameAs : sameAs( state.password.password ) }
            },
            agree : { sameAs : sameAs ( true ) }
         }
    });
    const v$ = useValidate(rules, state)
    async function fetchData() {
      loading.value = true;
      data.value = await store.state.keranjang;
      size.value = data.value.length;
      loading.value = false;
    }
    function deleteData(id){

    }

    onMounted(() => {
      fetchData();
    });

    return {
      data,
      size,
      loading,
      error,
      state,
      v$,
      deleteData,
      fetchData
    };
  },methods: {
    doSignIn() {
      localStorage.signup = !store.state.signup
      store.commit('togleSignUp')
      location.reload()
    },
    formModalDone() {
        console.log('asdf')
        this.modalShow = !this.modalShow
        this.modalCheckOutShow = false
        this.modalProductShow = false
        this.$nextTick().then(() => {
            this.fetchData()
        })
    },
    showModalProduct(title, index) {
        this.formTitle = title
        this.formData = title != 'Add Product' ? this.data[index] : null
        this.$nextTick().then(() => {
           if(title == 'Delete Product'){
            this.deleteData(this.formData.id)
           }else{
            this.modalShow = !this.modalShow
            this.modalProductShow = !this.modalProductShow
           }
        });
    },
    showCheckoutProduct(){
        this.modalShow = !this.modalShow
        this.modalCheckOutShow = !this.modalCheckOutShow
        this.checkOutData = this.data
        this.modalProductShow = false
    }
  }
}
</script>
<template> 
    <div class="container-fluid">
        <Loading v-if="loading" />
        <div class="row" v-if="!loading">
            <div class="col-lg-12" v-if="modalShow">
                <CheckoutForm v-if="modalCheckOutShow" @close-modal="formModalDone" :data="checkOutData" />
                <ProductForm v-if="modalProductShow" @close-modal="formModalDone" :title="formTitle" :data="formData" />
            </div>
            <div class="col-lg-12" v-if="!modalShow">
                <div class="d-flex flex-wrap flex-wrap align-items-center justify-content-between mb-4">
                    <div>
                        <h4 class="mb-3">Basket List</h4>
                        <!-- <p class="mb-0">The product list effectively dictates product presentation and provides space<br> to list your products and offering in the most appealing way.</p> -->
                    </div>
                    <a v-if="userRole == 'USER'" href="#product-checkout" class="btn btn-success add-list" @click="showCheckoutProduct('Product Checkout',null)" ><i class="ri-checkbox-multiple-line"></i>Continue to Checkout</a>
                </div>
            </div>
            <div class="col-lg-12" v-if="!modalShow">
                <div class="table-responsive rounded mb-3">
                <table class="data-tables table mb-0 tbl-server-info">
                    <thead class="bg-white text-uppercase">
                        <tr class="ligth ligth-data">
                            <!-- <th>
                                <div class="checkbox d-inline-block">
                                    <input type="checkbox" class="checkbox-input" id="checkbox1">
                                    <label for="checkbox1" class="mb-0"></label>
                                </div>
                            </th> -->
                            <th>Name</th>
                            <th>Code</th>
                            <th>Price</th>
                            <th>Unit</th>
                            <th>Weight</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody class="ligth-body">
                        <tr v-if="data && size > 0" v-for="(item, index) in data">
                            <!-- <td>
                                <div class="checkbox d-inline-block">
                                    <input type="checkbox" class="checkbox-input" id="checkbox2">
                                    <label for="checkbox2" class="mb-0"></label>
                                </div>
                            </td> -->
                            <td>
                                <div class="d-flex align-items-left">
                                    <img src="../assets/images/table/product/01.jpg" class="img-fluid rounded avatar-50 mr-3" alt="image">
                                    <div>
                                        {{item.name}}
                                        <p class="mb-0"><small>{{item.description}}</small></p>
                                    </div>
                                </div>
                            </td>
                            <td>{{item.code}}</td>
                            <td>SR. {{item.price}}</td>
                            <td>{{item.unit}}</td>
                            <td>{{item.weight || '-'}}</td>
                            <td>
                                <div v-if="userRole == 'USER'" class="d-flex align-items-left list-action">
                                    <a class="badge badge-info mr-2" :href="'#view-product-' + item.id" v-b-modal.modal-1 @click="showModalProduct('View Detail Product', index)" ><i class="ri-eye-line mr-0"></i></a>
                                </div>
                            </td>
                        </tr>
                        <tr v-if="size <= 0">
                            <td colspan="7"><i><strong> No Data Found </strong></i></td>
                        </tr>
                    </tbody>
                </table>
                </div>
            </div>
        </div>
    </div>
</template>
<style scoped>
.align-items-left{
    text-align: left;
}
</style>